.nolist
.include "m328pdef.inc" ; Define device ATmega328P
.list
;
; Soma os nmeros pares e mpares de 10 decrescendo at 1 e salva os resultados
; nas posies 0x100 (pares) e 0x101 (impares) da memoria de dados (SRAM).
; Exemplo de codificao de "while" e "if-then-else".

.ORG 0

   CLR R0			; R0: soma parcial dos pares
   CLR R1           ; R1: soma parcial dos impares
   CLR R16			; R16: auxiliar
   LDI R17, 0x0A	; R17: contador das parcelas

LOOP:                  ; inicio do loop
   CPI R17, 1          ; FLAGS <- ? (R17 - 1)
   BRMI FINAL          ; Se N=1, branch para FINAL
      MOV R16, R17     ; R16 <- parcela atual
      ANDI R16, 1     ; zera todos os bits exceto o bit 0
      BREQ ELSE_BLK    ; se Z=1 branch para ELSE_BLK
         ADD R1, R17   ; parcela impar: soma em R1 
         RJMP AHEAD    ; branch para AHEAD
ELSE_BLK:              ; bloco "ELSE"
         ADD R0, R17   ; parcela par: soma em R0
AHEAD:                 ; fim do bloco "ELSE"
      DEC R17	       ; proxima parcela
      RJMP LOOP 	   ; branch para loop
FINAL:                 ; fim do loop
   STS 0x100, R0	   ; DATA(0x100) <- soma dos pares
   STS 0x101, R1       ; DATA(0x101) <- soma dos impares
   SLEEP 


